unit WDMIO;

interface

function InitAIOWDM: Boolean;

type
  //8-bit
  TInPortB      = function (Port: LongWord): Word; cdecl;
  TOutPortB     = function (Port: LongWord; Value: Byte): Word; cdecl;

  //16-bit
  TInPort       = function (Port: LongWord): Word; cdecl;
  TOutPort      = function (Port: LongWord; Value: Word): Word; cdecl;

  //32-bit
  TInPortL      = function (Port: LongWord): LongWord; cdecl;
  TOutPortL     = function (Port: LongWord; Value: LongWord): Word; cdecl;

var
  AIOWDM_InPortB     : TInPortB     ;
  AIOWDM_OutPortB    : TOutPortB    ;
  AIOWDM_InPort      : TInPort      ;
  AIOWDM_OutPort     : TOutPort     ;
  AIOWDM_InPortL     : TInPortL     ;
  AIOWDM_OutPortL    : TOutPortL    ;












implementation

uses
  Windows;

function InitAIOWDM: Boolean;
var
  hLib: THandle;

  function GetProc(Nom: PChar): Pointer;
  begin
    Result := GetProcAddress(hLib, Nom);
    if Result = nil then InitAIOWDM := False;
  end;

begin
  Result := False;
  hLib := LoadLibrary('AIOWDM.dll');
  if (hLib = 0) or (hLib = INVALID_HANDLE_VALUE) then Exit;
  Result := True;

  AIOWDM_InPortB      := GetProc('InPortB');
  AIOWDM_OutPortB     := GetProc('OutPortB');
  AIOWDM_InPort       := GetProc('InPort');
  AIOWDM_OutPort      := GetProc('OutPort');
  AIOWDM_InPortL      := GetProc('InPortL');
  AIOWDM_OutPortL     := GetProc('OutPortL');
end;

end.